/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Drag de Go code.
 *
 * The Initial Developer of the Original Code is
 * Yukichi Kamata.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either of the GNU General Public License Version 2 or later (the "GPL"),
 * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var ddg_ges = {
	Cc : Components.classes,
	SaveAs: function(aData){
		if(aData.target == "images" && aData.src)
			saveImageURL(aData.src, null, "SaveImageTitle", false, false, getBrowser().currentURI);
		else if(aData.target == "text" && aData.text){
			var fp = ddgUtils.initFile("Save Text", getBrowser().contentTitle + ".txt");
			var Text = ddgUtils.ConvertFromUnicode(aData.text, ddg_Preferences.Prefs.CharSet);
			if (fp.show() == fp.returnCancel) return;
			ddgUtils.saveText(fp.file, Text);
		}else if(aData.url)
			saveURL(aData.url, aData.text, null, true, false, getBrowser().currentURI);
	},
	
	InstallXpi: function(aData){
		if(!aData.url) return;
		var params = [];
		params[aData.text] = {URL: aData.url};
		InstallTrigger.install(params);
	},
	
	SaveDf: function(aData, folder){
		if(!folder) folder = ddg_folderManager.getDfFolder(aData.target);
		if(folder){
			with(ddg_Preferences){
				if(Prefs.ConfirmSaving){
					var ps = this.Cc["@mozilla.org/embedcomp/prompt-service;1"].
							getService(nsCI.nsIPromptService);
					var chek = { value : true };
					var rv = ps.confirmCheck(window, ddg_StringS.getByName("save_warning.title"),
								 ddg_StringS.getByName("save_warning"), ddg_StringS.getByName("save_warning.check"), chek);
					if(!rv) return;
					if(!chek.value){
						Prefs.ConfirmSaving = false;
						set('ConfirmSaving', false);
					}
				}
			}
			if(aData.target == "text" && aData.text){
				var file = ddgUtils.initFileWithPath(folder);
				if(!file.exists()) return;
				var fName = getBrowser().contentTitle.replace(/[\$&\+,\/:;=\?@]/g, "-");
				file.append(fName + ".txt");
				file = ddgUtils.setLeafName(file);
				var Text = ddgUtils.ConvertFromUnicode(aData.text, ddg_Preferences.Prefs.CharSet);
				ddgUtils.saveText(file, Text);
			}else
				this.directSave(aData , folder);
		}else
			alert(ddg_StringS.getByName("folder_not_exist"));
	},

	Conquery: function(aData){
		document.popupNode = aData.sourceNode;
		cqrPageSelection = aData.text;
		cqrShowHotmenu(true, aData.lastX, aData.lastY);
	},

	Open: function(aData, aPath){
		if(!aData.url) return;
		if(aData.tipChanged){
			gURLBar.focus();
			gURLBar.value = aData.url;
			return;
		}
		var mode = aData.currAction.split("-");
		var postData = {value: null};
		var uri = getShortcutOrURI(aData.url, postData);
		if(mode[1] == "c")
			getBrowser().loadURI(uri, null, postData.value);
		else if(mode[1] == "h" || mode[1] == "f"){
			var bg = mode[1] == "h" ? true : false;
			if(mode[2]){
				var currTabIndex = getBrowser().mCurrentTab._tPos;
				var index = mode[2] == "r" ? currTabIndex + 1 : mode[2] == "l" ? currTabIndex : 0;
				getBrowser().moveTabTo(getBrowser().loadOneTab(uri, null, null, postData.value, bg), index);
			}else{
				getBrowser().loadOneTab(uri, null, null, postData.value, bg);
			}
		}else if(mode[1] == "ie" && aPath){
			var file = ddgUtils.initFileWithPath(aPath);
			if(!file.exists() || !file.isExecutable() || aPath.match(/\.lnk$/i))
				return;
			var process = this.Cc['@mozilla.org/process/util;1']
					.getService(nsCI.nsIProcess);
			process.init(file);
			var arguments = [];
			arguments.push(aData.url);
			process.run(false, arguments, arguments.length);
		}
	},
 	
 	SearchWith : {
 		popup : function(node, e){
 			if(node.id != e.target.id) return;
			var items = ddg_Search.getEngines();
			if(items.length > 0){
				node.Data = document.getElementById('ddg_mainCommandSet').Data;
				for each(var item in items)
					node.appendChild(this.createMenu(item));
			}
 		},
 		
 		clear : function(node, e){
 			if(node.id != e.target.id) return;
			node.Data = null;
			while (node.hasChildNodes()) node.removeChild(node.lastChild);
 		},
		
		createMenu : function(obj){
			var retItem = document.createElement("menuitem");
			with(retItem){
				className = "menuitem-iconic";
				setAttribute("label", obj.name);
				setAttribute("value", 'search-f--' + obj.name);
				setAttribute("tooltiptext", obj.name);
				setAttribute("src", obj.iconpath);
				setAttribute("oncommand", "this.parentNode.Data.currAction = this.value;ddg_ges.Search(this.parentNode.Data);");
			}
			return retItem;
		}
 	},
	
	Search : function(aData){
		var cAction = aData.currAction.split("--");
		if(cAction[1]){
			var mode = cAction[0].split("-");
			var engine = cAction[1];
			var sData = ddg_Search.getSearchURL(engine, aData.text);
		}else{
			var mode = aData.currAction.split("-");
			var sData = ddg_Search.getCurSearchURL(aData.text);
		}
		if(!sData.url) return;
		if(mode[1] == "c")
			getBrowser().loadURI(sData.url, null, sData.postData);
		else if(mode[1] == "h" || mode[1] == "f"){
			var bg = mode[1] == "h" ? true : false;
			if(mode[2]){
				var currTabIndex = getBrowser().mCurrentTab._tPos;
				var index = mode[2] == "r" ? currTabIndex + 1 : mode[2] == "l" ? currTabIndex : 0;
				getBrowser().moveTabTo(getBrowser().loadOneTab(sData.url, null, null, sData.postData, bg), index);
			}else{
				getBrowser().loadOneTab(sData.url, null, null, sData.postData, bg);
			}
		}
	},
	
	dragContext : {
		show : function(aData){
			document.getElementById('ddg_mainCommandSet').Data = aData;
			var node = document.getElementById('ddg_drag_context');
			node.Data = aData;
			document.popupNode = aData.sourceNode;
			node.showPopup(getBrowser(), aData.lastX, aData.lastY, 'context','bottomleft','topleft');
		},
		
		popup : function(node, e){
			if(e.target.id != "ddg_drag_context") return;
			var Target = node.Data.target;
			var mShow = ddg_Preferences.Prefs.DragContextMenus;
			var mShown = [];
			for(var i=0,h=0; i<node.childNodes.length; i++){
				if(node.childNodes[i].nodeName == "menu" || node.childNodes[i].nodeName == "menuitem"){
					if(/_go/.test(node.childNodes[i].id))
						node.childNodes[i].hidden = (Target == "text" || Target == "xpis" || !mShow[h]);
					else if(/(_search-|searchbar$|-findbar$)/.test(node.childNodes[i].id))
						node.childNodes[i].hidden = (Target == "images" || Target == "xpis" || !mShow[h]);
					else if(/-addon$/.test(node.childNodes[i].id))
						node.childNodes[i].hidden = (Target != "xpis" || !mShow[h]);
					else
						node.childNodes[i].hidden = !mShow[h];
					mShown.push(!node.childNodes[i].hidden);
					h++;
				}else if(node.childNodes[i].nodeName == "separator"){
					node.childNodes[i].hidden = !mShown.some(this.callback);
					mShown = [];
				}
			}
		},
		
		clear : function(node, e){
			if(e.target.id != "ddg_drag_context") return;
			node.Data = null;
			document.getElementById('ddg_mainCommandSet').Data = null;
		},
		
		callback : function(elem){
			return elem;
		}
	},
	
	openContext : {
		popup : function(node, e){
			if(node.id != e.target.id) return;
			node.Data = document.getElementById('ddg_mainCommandSet').Data;
			var Type = node.getAttribute("_Type");
			var Hidden = node.getAttribute("_Hidden");
			var items = [[ddg_StringS.getByName("open.right"), Type, Hidden, "-r"],
						[ddg_StringS.getByName("open.left"), Type, Hidden, "-l"],
						[ddg_StringS.getByName("open.first"), Type, Hidden, "-f"],
						[ddg_StringS.getByName("open.last"), Type, Hidden, ""]];
			for each(var item in items)
				node.appendChild(this.createMenu(item));
		},
		
		clear : function(node, e){
			if(node.id != e.target.id) return;
			node.Data = null;
			while (node.hasChildNodes()) node.removeChild(node.lastChild);
		},
		
		createMenu : function(aAttri){
			var retItem = document.createElement("menuitem");
			with(retItem){
				var CurrAction = aAttri[1]+aAttri[2]+aAttri[3];
				setAttribute("label", aAttri[0]);
				setAttribute("value", CurrAction);
				if(aAttri[1] == "go-")
					setAttribute("oncommand", "ddg_ges.openContext.open(this.parentNode.Data, this.value);");
				else if(aAttri[1] == "search-")
					setAttribute("oncommand", "ddg_ges.openContext.search(this.parentNode.Data, this.value);");
			}
			return retItem;
		},
		
		open : function(aData, aCurrAction){
			aData.currAction = aCurrAction;
			ddg_ges.Open(aData);
		},
		
		search : function(aData, aCurrAction){
			aData.currAction = aCurrAction;
			ddg_ges.Search(aData);
		}
	},
	
	externalapp : {
		popup : function(node){
			var items = ddg_folderManager.getFolders("externalapp");
			if(items.length > 0){
				node.Data = document.getElementById('ddg_mainCommandSet').Data;
				node.Data.currAction = 'go-ie';
				if(node.id == "ddg_popup_go-c-ie"){
					for each(var item in items)
						node.appendChild(this.createMenu(item, true));
				}else{
					for each(var item in items)
						node.appendChild(this.createMenu(item));
				}
				var sep = document.createElement("menuseparator");
				node.appendChild(sep);
			}
			var retItem = document.createElement("menuitem");
			retItem.setAttribute("label", ddg_StringS.getByName("externalapp.add"));
			retItem.setAttribute("oncommand", "ddg_folderManager.newNode('externalapp');");
			node.appendChild(retItem);
		},
		
		hide : function(node){
			node.Data = null;
			while (node.hasChildNodes()) node.removeChild(node.lastChild);
		},
		
		createMenu : function(obj, curr){
			var retItem = document.createElement("menuitem");
			with(retItem){
				className = "menuitem-iconic";
				setAttribute("label", obj.name);
				setAttribute("value", obj.path);
				setAttribute("tooltiptext", obj.path);
				var iSrc = "moz-icon:file:///" + obj.path + "?size=16";
				setAttribute("src", iSrc);
				if(!curr)
					setAttribute("oncommand", "ddg_ges.Open(this.parentNode.Data, this.value);");
				else
					setAttribute("oncommand", "this.parentNode.Data.url=getBrowser().currentURI.spec;ddg_ges.Open(this.parentNode.Data, this.value);");
			}
			return retItem;
		}
	},
	
	saveMenu : {
		show : function(aData){
			var node = document.getElementById('ddg_FolderMenu');
			node.Data = aData;
			document.popupNode = aData.sourceNode
			node.showPopup(getBrowser(), aData.lastX, aData.lastY, 'context','bottomleft','topleft');
		},
		
		popup : function(node, dragContext){
			if(!node.Data) node.Data = document.getElementById('ddg_mainCommandSet').Data;
			var items = ddg_folderManager.getFolders(node.Data.target);
			var SaveAs = ddg_Preferences.Prefs.ShowSaveAsMenu;
			var AddFolder = ddg_Preferences.Prefs.ShowAddFolderMenu;
			var mFlashGot = 'gFlashGot' in window;
			if(items.length > 0){
				for each(var item in items)
					node.appendChild(this.createMenu(item));
				if(AddFolder || SaveAs || mFlashGot)
					node.appendChild(document.createElement("menuseparator"));
			}
			if(AddFolder || dragContext){
				node.appendChild(this.createExMenu(ddg_StringS.getByName("saveMenu.addfolder"), "ddg_folderManager.addNewFolder(this.parentNode.Data);"));
			}
			if(SaveAs || dragContext){
				if(node.Data.target == "text")
					node.appendChild(this.createExMenu(ddg_StringS.getByName("g.save-text"), "ddg_ges.SaveAs(this.parentNode.Data);"));
				else if(node.Data.target == "images")
					node.appendChild(this.createExMenu(ddg_StringS.getByName("g.save-Img"), "ddg_ges.SaveAs(this.parentNode.Data);"));
				else if(node.Data.target == "links")
					node.appendChild(this.createExMenu(ddg_StringS.getByName("g.save-link"), "ddg_ges.SaveAs(this.parentNode.Data);"));
				else if(node.Data.target == "xpis")
					node.appendChild(this.createExMenu(ddg_StringS.getByName("g.save-addon"), "ddg_ges.SaveAs(this.parentNode.Data);"));
			}
			if(mFlashGot && node.Data.target != "text")
				node.appendChild(this.createExMenu(ddg_StringS.getByName("g.flashGot"), "ddg_ges.flashgot(this.parentNode.Data);", "chrome://flashgot/skin/fg1.png"));
		},
		
		clear : function(node){
			node.Data = null;
			while (node.hasChildNodes()) node.removeChild(node.lastChild);
		},
		
		createMenu : function(obj){
			var retItem = document.createElement("menuitem");
			with(retItem){
				setAttribute("label", obj.name);
				setAttribute("value", obj.path);
				setAttribute("tooltiptext", obj.path);
				setAttribute("oncommand", "ddg_ges.SaveDf(this.parentNode.Data, this.value);");
			}
			return retItem;
		},
		
		createExMenu : function(aLabel, aCommand, aImage){
			var retItem = document.createElement("menuitem");
			with(retItem){
				setAttribute("label", aLabel);
				setAttribute("oncommand", aCommand);
				if(aImage){
					className = "menuitem-iconic flashgot-icon-sel";
					setAttribute("image", aImage);
				}
			}
			return retItem;
		}
	},
	
	flashgot : function(data){
		var links = [];
		try {
			links[0] = {href: data.src, description: data.text}
			links.startTime = new Date().getTime();
			links.referrer = getBrowser().currentURI.spec;
			links.document = data.sourceNode;
			links.progress = gFlashGot.createProgress();
			gFlashGotService.download(links, gFlashGotService.OP_ONE, null);
		} catch(ex) {}
	},
	
	getDownloadFolder: function(afolder){
		if(/^(\.)/.test(afolder)){
			var FFdir = ddgUtils.getDir("CurProcD");
			FFdir.appendRelativePath(afolder);
			return ddgUtils.initFileWithPath(FFdir.path);
		}else{
			return ddgUtils.initFileWithPath(afolder);
		}
	},
	
	directSave: function(aData, afolder){
		if(!aData.src) return;
		var saveMode = GetSaveModeForContentType(null);
		var saveAsType = kSaveAsType_Complete;
		var file, fileURL;
		var fileInfo = new FileInfo(aData.text);
		var charset = null;
		initFileInfo(fileInfo, aData.src, charset, null, null, null);
		
		var fileSaving = this.getDownloadFolder(afolder);
		
		if (!fileSaving.exists() || !fileSaving.isDirectory()){
			alert(ddg_StringS.getByName("folder_not_exist"));
			return;
		}
		fileSaving.append(getNormalizedLeafName(fileInfo.fileName, fileInfo.fileExt));
		fileSaving = ddgUtils.setLeafName(fileSaving);
		
		var path = fileSaving.path;
		var newFileName = fileSaving.leafName;
		var uri     = fileInfo.uri;
		var hosturi = getBrowser().currentURI;
		var mimeInfo = null;
		try {
			mimeInfo = getMIMEService().getFromTypeAndExtension(null, fileInfo.fileExt);
		} catch (e) { }

		var targetUrl = makeFileURI(fileSaving);
		var persist = this.Cc['@mozilla.org/embedding/browser/nsWebBrowserPersist;1'].
					createInstance(nsCI.nsIWebBrowserPersist);
		//ddgUtils.Log(aData.text +"\n"+ aData.url +"\n"+ aData.src +"\n"+ hosturi.spec +"\n"+ path);
		// Calculate persist flags.
		const nsIWBP = nsCI.nsIWebBrowserPersist;
		const flags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
		persist.persistFlags |= nsIWBP.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;
		persist.persistFlags |= nsIWBP.PERSIST_FLAGS_CLEANUP_ON_FAILURE;
		
		var cacheKey = null;
		if(aData.target == "images"){
			persist.persistFlags = flags | nsIWBP.PERSIST_FLAGS_FROM_CACHE;
			cacheKey  = this.Cc['@mozilla.org/supports-string;1'].createInstance(nsCI.nsISupportsString);
			cacheKey.data = uri;
		}else{
			persist.persistFlags = flags | nsIWBP.PERSIST_FLAGS_BYPASS_CACHE;
		}
		ddg_DownloadStatusHandler.addDownload(newFileName);
		persist.progressListener = ddg_DownloadStatusHandler;
		persist.saveURI(uri, cacheKey, hosturi, null, null, targetUrl);
	},
	
	searchBox: {
		update: function(aData, mode){
			if(mode == 0) this.value = "";
			else this.value = aData.text;
		},
		
		get ref() {
			return document.getElementById("searchbar");
		},
		
		set value(aValue) {
			if(this.ref){
				if(this.ref.mTextbox){
					this.ref.mTextbox.value = aValue;
					var evt = document.createEvent("Events");
					evt.initEvent("oninput", true, true);
					this.ref.dispatchEvent(evt);
				}else{
					this.ref.value = aValue;
				}
			}
		}
	}
}

var ddg_DownloadStatusHandler = {
	STATE_STOP: nsCI.nsIWebProgressListener.STATE_STOP,
	STATE_START: nsCI.nsIWebProgressListener.STATE_START,
	STATE_TRANSFERRING: nsCI.nsIWebProgressListener.STATE_TRANSFERRING,
	currentState : [],
	disabled: true,
	enable: true,
	
	init : function(){
		this.disabled = false;
		this.statusBar = document.getElementById("ddg-progresspanel");
		this.pMeter = document.getElementById("ddg-progressmeter");
		this.enable = ddg_Preferences.Prefs.ShowProgress;
		if(this.enable) this.statusBar.setAttribute("collapsed", false);
		this.pMeter.value = 0;
	},
	
	uninit : function(){
		this.disabled = true;
		this.statusBar.setAttribute("collapsed", true);
		this.statusBar = this.pMeter = null;
		this.currentState = [];
	},
	
	QueryInterface : function(aIID) {
		if (aIID.equals(nsCI.nsIWebProgressListener) ||
			aIID.equals(nsCI.nsISupportsWeakReference) ||
			aIID.equals(nsCI.nsISupports))
			return this;
		throw Components.results.NS_NOINTERFACE;
	},
	
	onStateChange:function(aProgress,aRequest,aFlag,aStatus) {
		if(aFlag & this.STATE_START) {
			for each (var state in this.currentState){
				if(!state.path){
					state.path = aRequest.name;
					state.complete = false;
					break;
				}
			}
		}else if(aFlag & this.STATE_STOP) {
			for each (var state in this.currentState){
				if(!state.complete && state.path == aRequest.name && state.curSelfProgress == state.maxSelfProgress){
					state.complete = true;
					var SaveLabel="The file has been saved as " + state.fileName;
					ddgUtils.sBarMessage(SaveLabel, 3000);
					break;
				}
			}
			if(this.currentState.every(this.checkcomplete))
				this.uninit();
		}
	},
	
	onProgressChange:function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress){
		if(aMaxSelfProgress > 0) {
			var aCurTotalProgress = 0, aMaxTotalProgress = 0;
			for each (var state in this.currentState){
				if(state.path == aRequest.name && aCurSelfProgress >= state.curSelfProgress){
					state.curSelfProgress = aCurSelfProgress;
					state.maxSelfProgress = aMaxSelfProgress;
					break;
				}
			}
			for each (var state in this.currentState){
				aCurTotalProgress += state.curSelfProgress;
				aMaxTotalProgress += state.maxSelfProgress;
			}
			if(this.enable) this.pMeter.value = Math.ceil((aCurTotalProgress/aMaxTotalProgress) * 100);
		}
	},
	
	addDownload : function(fileName){
		if(this.disabled) this.init();
		this.currentState.push(new this.State(fileName));
	},
	
	State : function(fileName){
		this.path = null;
		this.fileName = fileName;
		this.curSelfProgress = 0;
		this.maxSelfProgress = 0;
		this.complete = true;
	},
	checkcomplete : function(element){
		return element.complete
	},
	onLocationChange:function(){},
	onStatusChange:function(){},
	onSecurityChange:function(){}
}

