/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Drag de Go code.
 *
 * The Initial Developer of the Original Code is
 * Yukichi Kamata.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either of the GNU General Public License Version 2 or later (the "GPL"),
 * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var ddg_Tooltip = {
	xhtmlNS : "http://www.w3.org/1999/xhtml",
	frameTip : null,
	toolTip : null,
	targetDoc : null,
	
	Init : function(e){
		this.targetDoc = e.view.document;
		if (this.targetDoc.contentType == "application/vnd.mozilla.xul+xml")
			return;
		this.frameTip = this.targetDoc.createElementNS(this.xhtmlNS, "ddg_frameTip");
		this.targetDoc.documentElement.appendChild(this.frameTip);
	},
	
	unInit : function(){
		ddg_Tooltip.remove();
		this.targetDoc = this.frameTip = this.toolTip = null;
	},
	
	show : function(e, aText, aData){
		if(!this.targetDoc || !this.frameTip) return;
		with(aData){
			if(this.toolTip){
				if(!stayCnt && delayCnt % 5 == 0){
					this.toolTip.textContent = aText;
					if(moveTooltip){
						var tStyle = this.toolTip.style;
						var x = lastX - tipStyle[0];
						var y = lastY + 20;
						tStyle.left = x > 0 ? x + "px" : "0px";
						tStyle.top = y > 0 ? y + "px" : "0px";
					}
				}
			}else if(this.targetDoc && this.frameTip){
				if(moveTooltip)
					this.addTip(lastX, lastY, aText, tipStyle);
				else
					this.addTip(startX, startY, aText, tipStyle);
			}
		}
	},
	
	remove : function(){
		if (this.frameTip && this.frameTip.parentNode)
			this.frameTip.parentNode.removeChild(this.frameTip);
	},
	
	hide : function(){
		if (this.frameTip && this.toolTip){
			this.frameTip.removeChild(this.toolTip);
			this.toolTip = null;
			ddg_StatusMessage("");
		}
	},
	
	changeText : function(aText){
		if(this.toolTip) this.toolTip.textContent = aText;
	},
	
	addTip : function(x, y, aText, aStyle) {
		this.toolTip = this.targetDoc.createElement ("DIV");
		with(this.toolTip){
			id = "ddg_Tooltip";
			textContent = aText;
			var dStyle = style;
		}
		with(dStyle){
			fontWeight = "bold";
			padding = "3px";
			border = "1px solid #E0E0E0";
			zIndex = 10000;
			position = "absolute";
			x = x - aStyle[0];
			y = y + 20;
			left = x > 0 ? x + "px" : "0px";
			top = y > 0 ? y + "px" : "0px";
			MozBorderRadius = aStyle[0]/2 + "px";
			background = aStyle[3];
			opacity = aStyle[1]/10;
			color = aStyle[2];
			fontSize = aStyle[0] + "px";
			if(aStyle[5]) fontFamily = decodeURIComponent(aStyle[5]);
		}
		this.frameTip.appendChild(this.toolTip);
	}
}
