/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Drag de Go code.
 *
 * The Initial Developer of the Original Code is
 * Yukichi Kamata.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either of the GNU General Public License Version 2 or later (the "GPL"),
 * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

//////////// Drag and Dorp bserver: replace contentAreaDNDObserver with it. ///////////////////
var nsCI = Components.interfaces;
var ViewSourceDNDObserver = {
	StartAlready:false,
	OverAlready:false,
	drag_data:null,
	timer:null,
	Dropped:false,
	eTimer:null,
	
	onDragStart: function(e, aXferData, dragAction){
		if(ddg_Preferences.Prefs.Saction[0] == 4) return;
		if(this.StartAlready || this.OverAlready) this.unInit();
		
		this.drag_data = new ddg_VData();
		this.StartAlready = true;
		with(this.drag_data){
			action = ddg_Preferences.Prefs.Saction;
			startX = lastX = e.pageX;
			startY = lastY = e.pageY;
			showTooltip = ddg_Preferences.Prefs.showTooltip;
			if(showTooltip){
				tipStyle = ddg_Preferences.Prefs.tipStyle;
				moveTooltip = ddg_Preferences.Prefs.moveEnable;
				ddg_Tooltip.Init(e);
			}
		}
		
		function ddg_VData(){
			this.target = "text";
			this.text = null;
			this.startX = null;
			this.startY = null;
			this.action = [];
			this.lastX = null;
			this.lastY = null;
			this.delayCnt = 0;
			this.stayCnt = 0;
			this.currAction = null;
			this.showTooltip = false;
			this.moveTooltip = false;
			this.tipStyle = [];
			this.tipChanged = false;
			this.sourceNode = null;
		}
	},
	
	onDragOver: function(e, aFlavour, aDragSession){
		var SourceNode = aDragSession.sourceNode;
		if(!this.StartAlready){
			return;
		}else if(!SourceNode){
			this.unInit();
		}else if(!this.OverAlready){
			var transData = ddgUtils.getTransferData(aFlavour.contentType, aDragSession);
			
			if(transData.dataObj.value){
				var DataObj = transData.dataObj.value.QueryInterface(nsCI.nsISupportsString);
				var sourceUri = DataObj.data.substring(0, transData.len.value);
				var DragData = sourceUri.split("\n");
				this.drag_data.text = DragData[0];
				this.drag_data.sourceNode = SourceNode;
			}
			this.OverAlready = true;
		}
	},
	
	onDrop: function (e, aDropData, aDragSession){
		if(this.StartAlready){
			this.Dropped = true;
			with(this.drag_data){
				lastX = e.clientX;
				lastY = e.clientY;
				tipChanged = e.ctrlKey ? true : tipChanged;
			}
			if(ddg_Preferences.Prefs.EnableTimeout){
				window.addEventListener('mousedown', ViewSourceDNDObserver.TimeoutHandler.onMouseDown, true);
				window.addEventListener('click', ViewSourceDNDObserver.TimeoutHandler.onClick, false);
				this.eTimer = setTimeout(function() {
					window.removeEventListener('mousedown', ViewSourceDNDObserver.TimeoutHandler.onMouseDown, true);
					window.removeEventListener('click', ViewSourceDNDObserver.TimeoutHandler.onClick, false);
					ddg_ViewSource.DoGesture(ViewSourceDNDObserver.drag_data);
					ViewSourceDNDObserver.unInit();
				}, ddg_Preferences.Prefs.TimeoutPeriod);
			}else{
				ddg_ViewSource.DoGesture(ViewSourceDNDObserver.drag_data);
				ViewSourceDNDObserver.unInit();
			}
		}
		e.preventDefault();
		e.stopPropagation();
	},
	
	unInit: function(){
		ddg_Tooltip.unInit();
		with(this){
			if(timer){
				clearTimeout(timer);
				timer = null;
			}
			if(eTimer){
				clearTimeout(eTimer);
				eTimer = null;
			}
			OverAlready = StartAlready = false;
			drag_data = null;
		}
	},
	
	onDragExit: function(e, aDragSession){
		this.timer = setTimeout(ViewSourceDNDObserver.checkSession, 1000);
	},
	
	checkSession : function(){
		var currSession = Components.classes["@mozilla.org/widget/dragservice;1"].
				getService(nsCI.nsIDragService).getCurrentSession();
		with(ViewSourceDNDObserver){
			if(timer){
				clearTimeout(timer);
				timer = null;
			}
			if(currSession){
				timer = setTimeout(checkSession, 1000);
			}else if(!Dropped){
				ddgUtils.sBarMessage("");
				unInit();
			}
		}
	},
	
	canDrop : function(e, aDragSession){
		if(this.timer){
			clearTimeout(this.timer);
			this.timer = null;
		}
		if(this.OverAlready){
			with(this.drag_data){
				if(e.type == "dragover"){
					var currentX = e.pageX;
					var currentY = e.pageY;
					if(lastX == currentX && lastY == currentY){
						if(stayCnt <= 100) stayCnt++;
						delayCnt += 5;
					}else{
						stayCnt = 0;
						delayCnt++;
					}
					lastX = currentX;
					lastY = currentY;
					var direction = ddg_ViewSource.Direction(this.drag_data);
					currAction = action[direction];
					var Message = ddg_StringS.getByName("g."+ currAction);
					ddgUtils.sBarMessage(Message);
					if(showTooltip && delayCnt >= tipStyle[4])
						ddg_Tooltip.show(e ,Message, this.drag_data);
				}
				if(currAction != "do-nothing") return true;
			}
		}
		return false;
	},
	
	TimeoutHandler : {
		onClick : function(e){
			ViewSourceDNDObserver.unInit();
			ddgUtils.sBarMessage(ddg_StringS.getByName("gesture.aborted"), 2000);
			window.removeEventListener('mousedown', ViewSourceDNDObserver.TimeoutHandler.onMouseDown, true);
			window.removeEventListener('click', ViewSourceDNDObserver.TimeoutHandler.onClick, false);
			e.preventDefault();
			e.stopPropagation();
		},
		
		onMouseDown : function(e){
			ViewSourceDNDObserver.unInit();
			window.removeEventListener('mousedown', ViewSourceDNDObserver.TimeoutHandler.onMouseDown, true);
			window.removeEventListener('click', ViewSourceDNDObserver.TimeoutHandler.onClick, false);
			window.addEventListener('click', ViewSourceDNDObserver.TimeoutHandler.onMouseUp, true);
			ddgUtils.sBarMessage(ddg_StringS.getByName("gesture.aborted"), 2000);
		},
		
		onMouseUp : function(e){
			window.removeEventListener('click', ViewSourceDNDObserver.TimeoutHandler.onMouseUp, true);
			e.preventDefault();
			e.stopPropagation();
		}
	},
	
	getSupportedFlavours: function (){
		var flavourSet = new FlavourSet();
		flavourSet.appendFlavour("text/x-moz-url");
		flavourSet.appendFlavour("application/x-moz-file", "nsIFile");
		flavourSet.appendFlavour("text/unicode");
		flavourSet.appendFlavour("text/html");
		return flavourSet;
	}
}
var ddg_StatusBar;
var ddg_ViewSource = {
	onLoad: function(){
		window.addEventListener('unload', ddg_ViewSource.unLoad, false);
		window.removeEventListener('load', ddg_ViewSource.onLoad, true);
		getBrowser().addEventListener('draggesture', function(event) {nsDragAndDrop.startDrag(event, ViewSourceDNDObserver);} , true);
		getBrowser().setAttribute('ondragover', 'nsDragAndDrop.dragOver(event, ViewSourceDNDObserver)');
		getBrowser().setAttribute('ondragdrop', 'nsDragAndDrop.drop(event, ViewSourceDNDObserver)');
		getBrowser().setAttribute('ondragexit', 'nsDragAndDrop.dragExit(event, ViewSourceDNDObserver)');
		ddg_StatusBar = document.getElementById("statusbar-line-col");
		ddg_Preferences.loadPrefs();
	},
	
	unLoad: function(){
		getBrowser().removeEventListener('draggesture', function(event) {nsDragAndDrop.startDrag(event, ViewSourceDNDObserver);} , true);
		window.removeEventListener('unload', ddg_ViewSource.unLoad, false);
	},
	
	DoGesture: function (aData){
		switch (aData.currAction) {
			case "paste-findbar" :
				ddg_findBar(aData, 1);break;
			case "delete-findbar" :
				ddg_findBar(aData, 0);break;
			case "saveMenu":
				ddg_ges.saveMenu.show(aData);break;
			default:
				if(/^save-df-/.test(aData.currAction))
					ddg_ges.SaveDf(aData);
				else if(/^save-(link|addon|Img|text)$/.test(aData.currAction))
					ddg_ges.SaveAs(aData);
		}
	},

	Direction : function(aData){
		var X = aData.lastX - aData.startX;
		var Y = aData.lastY - aData.startY;
		if(aData.action[0] == 0)
			return (Math.abs(X) - Math.abs(Y))>0 ? (X>0 ? 1 : 2) : (Y>0 ? 3 : 4) ;
		else if(aData.action[0] == 1)
			return Y>0 ? 3 : 4 ;
		else if(aData.action[0] == 2)
			return X>0 ? 1 : 2 ;
		else
			return 4;
	}
}

window.addEventListener('load', ddg_ViewSource.onLoad, true);
